summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorEray Aslan <eras@gentoo.org>2014-09-29 14:11:12 +0000
committerEray Aslan <eras@gentoo.org>2014-09-29 14:11:12 +0000
commit65bba5b3fe823654bff26df9c9cf57333ab44be6 (patch)
tree295fcbf6b234838735515f7ad37d1a06ea60c9ce /net-proxy
parentAdd missing dependencies fixing bug 523972 (diff)
downloadgentoo-2-65bba5b3fe823654bff26df9c9cf57333ab44be6.tar.gz
gentoo-2-65bba5b3fe823654bff26df9c9cf57333ab44be6.tar.bz2
gentoo-2-65bba5b3fe823654bff26df9c9cf57333ab44be6.zip
Security bump - bug #522498
(Portage version: 2.2.14_rc1/cvs/Linux x86_64, signed Manifest commit with key 0x77F1F175586A3B1F)
Diffstat (limited to 'net-proxy')
-rw-r--r--net-proxy/squid/ChangeLog10
-rw-r--r--net-proxy/squid/files/squid-12683_12681.patch274
-rw-r--r--net-proxy/squid/files/squid-13173_13171.patch274
-rw-r--r--net-proxy/squid/squid-3.3.13-r1.ebuild250
-rw-r--r--net-proxy/squid/squid-3.4.7-r1.ebuild256
5 files changed, 1063 insertions, 1 deletions
diff --git a/net-proxy/squid/ChangeLog b/net-proxy/squid/ChangeLog
index 1a7499ddd613..b554324949c7 100644
--- a/net-proxy/squid/ChangeLog
+++ b/net-proxy/squid/ChangeLog
@@ -1,6 +1,14 @@
# ChangeLog for net-proxy/squid
# Copyright 1999-2014 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/net-proxy/squid/ChangeLog,v 1.479 2014/09/19 12:03:13 eras Exp $
+# $Header: /var/cvsroot/gentoo-x86/net-proxy/squid/ChangeLog,v 1.480 2014/09/29 14:11:12 eras Exp $
+
+*squid-3.4.7-r1 (29 Sep 2014)
+*squid-3.3.13-r1 (29 Sep 2014)
+
+ 29 Sep 2014; Eray Aslan <eras@gentoo.org> +files/squid-12683_12681.patch,
+ +files/squid-13173_13171.patch, +squid-3.3.13-r1.ebuild,
+ +squid-3.4.7-r1.ebuild:
+ Security bump - bug #522498
19 Sep 2014; Eray Aslan <eras@gentoo.org> -squid-3.3.12.ebuild,
-squid-3.4.3.ebuild, -squid-3.4.4.ebuild, -squid-3.4.5.ebuild,
diff --git a/net-proxy/squid/files/squid-12683_12681.patch b/net-proxy/squid/files/squid-12683_12681.patch
new file mode 100644
index 000000000000..27847a350289
--- /dev/null
+++ b/net-proxy/squid/files/squid-12683_12681.patch
@@ -0,0 +1,274 @@
+=== modified file 'src/snmp_core.cc'
+--- src/snmp_core.cc 2012-10-16 23:40:01 +0000
++++ src/snmp_core.cc 2014-09-15 04:59:19 +0000
+@@ -362,7 +362,7 @@
+ void
+ snmpHandleUdp(int sock, void *not_used)
+ {
+- LOCAL_ARRAY(char, buf, SNMP_REQUEST_SIZE);
++ static char buf[SNMP_REQUEST_SIZE];
+ Ip::Address from;
+ SnmpRequest *snmp_rq;
+ int len;
+@@ -371,16 +371,11 @@
+
+ Comm::SetSelect(sock, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
+
+- memset(buf, '\0', SNMP_REQUEST_SIZE);
++ memset(buf, '\0', sizeof(buf));
+
+- len = comm_udp_recvfrom(sock,
+- buf,
+- SNMP_REQUEST_SIZE,
+- 0,
+- from);
++ len = comm_udp_recvfrom(sock, buf, sizeof(buf)-1, 0, from);
+
+ if (len > 0) {
+- buf[len] = '\0';
+ debugs(49, 3, "snmpHandleUdp: FD " << sock << ": received " << len << " bytes from " << from << ".");
+
+ snmp_rq = (SnmpRequest *)xcalloc(1, sizeof(SnmpRequest));
+
+=== modified file 'src/icmp/Icmp4.cc'
+--- src/icmp/Icmp4.cc 2013-01-09 00:19:44 +0000
++++ src/icmp/Icmp4.cc 2014-09-15 05:07:44 +0000
+@@ -41,26 +41,38 @@
+ #include "IcmpPinger.h"
+ #include "Debug.h"
+
+-const char *icmpPktStr[] = {
+- "Echo Reply",
+- "ICMP 1",
+- "ICMP 2",
+- "Destination Unreachable",
+- "Source Quench",
+- "Redirect",
+- "ICMP 6",
+- "ICMP 7",
+- "Echo",
+- "ICMP 9",
+- "ICMP 10",
+- "Time Exceeded",
+- "Parameter Problem",
+- "Timestamp",
+- "Timestamp Reply",
+- "Info Request",
+- "Info Reply",
+- "Out of Range Type"
+-};
++static const char *
++IcmpPacketType(uint8_t v)
++{
++ static const char *icmpPktStr[] = {
++ "Echo Reply",
++ "ICMP 1",
++ "ICMP 2",
++ "Destination Unreachable",
++ "Source Quench",
++ "Redirect",
++ "ICMP 6",
++ "ICMP 7",
++ "Echo",
++ "ICMP 9",
++ "ICMP 10",
++ "Time Exceeded",
++ "Parameter Problem",
++ "Timestamp",
++ "Timestamp Reply",
++ "Info Request",
++ "Info Reply",
++ "Out of Range Type"
++ };
++
++ if (v > 17) {
++ static char buf[50];
++ snprintf(buf, sizeof(buf), "ICMP %u (invalid)", v);
++ return buf;
++ }
++
++ return icmpPktStr[v];
++}
+
+ Icmp4::Icmp4() : Icmp()
+ {
+@@ -187,6 +199,12 @@
+ from->ai_addr,
+ &from->ai_addrlen);
+
++ if (n <= 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Error when calling recvfrom() on ICMP socket.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ preply.from = *from;
+
+ #if GETTIMEOFDAY_NO_TZP
+@@ -243,9 +261,15 @@
+
+ preply.psize = n - iphdrlen - (sizeof(icmpEchoData) - MAX_PKT4_SZ);
+
++ if (preply.psize < 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Malformed ICMP packet.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ control.SendResult(preply, (sizeof(pingerReplyData) - MAX_PKT4_SZ + preply.psize) );
+
+- Log(preply.from, icmp->icmp_type, icmpPktStr[icmp->icmp_type], preply.rtt, preply.hops);
++ Log(preply.from, icmp->icmp_type, IcmpPacketType(icmp->icmp_type), preply.rtt, preply.hops);
+ preply.from.FreeAddrInfo(from);
+ }
+
+
+=== modified file 'src/icmp/Icmp6.cc'
+--- src/icmp/Icmp6.cc 2013-01-09 00:19:44 +0000
++++ src/icmp/Icmp6.cc 2014-09-15 05:07:44 +0000
+@@ -50,57 +50,61 @@
+
+ // Icmp6 OP-Codes
+ // see http://www.iana.org/assignments/icmpv6-parameters
+-// NP: LowPktStr is for codes 0-127
+-static const char *icmp6LowPktStr[] = {
+- "ICMP 0", // 0
+- "Destination Unreachable", // 1 - RFC2463
+- "Packet Too Big", // 2 - RFC2463
+- "Time Exceeded", // 3 - RFC2463
+- "Parameter Problem", // 4 - RFC2463
+- "ICMP 5", // 5
+- "ICMP 6", // 6
+- "ICMP 7", // 7
+- "ICMP 8", // 8
+- "ICMP 9", // 9
+- "ICMP 10" // 10
+-};
+-
+-// NP: HighPktStr is for codes 128-255
+-static const char *icmp6HighPktStr[] = {
+- "Echo Request", // 128 - RFC2463
+- "Echo Reply", // 129 - RFC2463
+- "Multicast Listener Query", // 130 - RFC2710
+- "Multicast Listener Report", // 131 - RFC2710
+- "Multicast Listener Done", // 132 - RFC2710
+- "Router Solicitation", // 133 - RFC4861
+- "Router Advertisement", // 134 - RFC4861
+- "Neighbor Solicitation", // 135 - RFC4861
+- "Neighbor Advertisement", // 136 - RFC4861
+- "Redirect Message", // 137 - RFC4861
+- "Router Renumbering", // 138 - Crawford
+- "ICMP Node Information Query", // 139 - RFC4620
+- "ICMP Node Information Response", // 140 - RFC4620
+- "Inverse Neighbor Discovery Solicitation", // 141 - RFC3122
+- "Inverse Neighbor Discovery Advertisement", // 142 - RFC3122
+- "Version 2 Multicast Listener Report", // 143 - RFC3810
+- "Home Agent Address Discovery Request", // 144 - RFC3775
+- "Home Agent Address Discovery Reply", // 145 - RFC3775
+- "Mobile Prefix Solicitation", // 146 - RFC3775
+- "Mobile Prefix Advertisement", // 147 - RFC3775
+- "Certification Path Solicitation", // 148 - RFC3971
+- "Certification Path Advertisement", // 149 - RFC3971
+- "ICMP Experimental (150)", // 150 - RFC4065
+- "Multicast Router Advertisement", // 151 - RFC4286
+- "Multicast Router Solicitation", // 152 - RFC4286
+- "Multicast Router Termination", // 153 - [RFC4286]
+- "ICMP 154",
+- "ICMP 155",
+- "ICMP 156",
+- "ICMP 157",
+- "ICMP 158",
+- "ICMP 159",
+- "ICMP 160"
+-};
++static const char *
++IcmpPacketType(uint8_t v)
++{
++ // NP: LowPktStr is for codes 0-127
++ static const char *icmp6LowPktStr[] = {
++ "ICMPv6 0", // 0
++ "Destination Unreachable", // 1 - RFC2463
++ "Packet Too Big", // 2 - RFC2463
++ "Time Exceeded", // 3 - RFC2463
++ "Parameter Problem", // 4 - RFC2463
++ };
++
++ // low codes 1-4 registered
++ if (0 < v && v < 5)
++ return icmp6LowPktStr[(int)(v&0x7f)];
++
++ // NP: HighPktStr is for codes 128-255
++ static const char *icmp6HighPktStr[] = {
++ "Echo Request", // 128 - RFC2463
++ "Echo Reply", // 129 - RFC2463
++ "Multicast Listener Query", // 130 - RFC2710
++ "Multicast Listener Report", // 131 - RFC2710
++ "Multicast Listener Done", // 132 - RFC2710
++ "Router Solicitation", // 133 - RFC4861
++ "Router Advertisement", // 134 - RFC4861
++ "Neighbor Solicitation", // 135 - RFC4861
++ "Neighbor Advertisement", // 136 - RFC4861
++ "Redirect Message", // 137 - RFC4861
++ "Router Renumbering", // 138 - Crawford
++ "ICMP Node Information Query", // 139 - RFC4620
++ "ICMP Node Information Response", // 140 - RFC4620
++ "Inverse Neighbor Discovery Solicitation", // 141 - RFC3122
++ "Inverse Neighbor Discovery Advertisement", // 142 - RFC3122
++ "Version 2 Multicast Listener Report", // 143 - RFC3810
++ "Home Agent Address Discovery Request", // 144 - RFC3775
++ "Home Agent Address Discovery Reply", // 145 - RFC3775
++ "Mobile Prefix Solicitation", // 146 - RFC3775
++ "Mobile Prefix Advertisement", // 147 - RFC3775
++ "Certification Path Solicitation", // 148 - RFC3971
++ "Certification Path Advertisement", // 149 - RFC3971
++ "ICMP Experimental (150)", // 150 - RFC4065
++ "Multicast Router Advertisement", // 151 - RFC4286
++ "Multicast Router Solicitation", // 152 - RFC4286
++ "Multicast Router Termination", // 153 - [RFC4286]
++ };
++
++ // high codes 127-153 registered
++ if (127 < v && v < 154)
++ return icmp6HighPktStr[(int)(v&0x7f)];
++
++ // give all others a generic display
++ static char buf[50];
++ snprintf(buf, sizeof(buf), "ICMPv6 %u", v);
++ return buf;
++}
+
+ Icmp6::Icmp6() : Icmp()
+ {
+@@ -236,6 +240,12 @@
+ from->ai_addr,
+ &from->ai_addrlen);
+
++ if (n <= 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Error when calling recvfrom() on ICMPv6 socket.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ preply.from = *from;
+
+ #if GETTIMEOFDAY_NO_TZP
+@@ -291,8 +301,7 @@
+
+ default:
+ debugs(42, 8, HERE << preply.from << " said: " << icmp6header->icmp6_type << "/" << (int)icmp6header->icmp6_code << " " <<
+- ( icmp6header->icmp6_type&0x80 ? icmp6HighPktStr[(int)(icmp6header->icmp6_type&0x7f)] : icmp6LowPktStr[(int)(icmp6header->icmp6_type&0x7f)] )
+- );
++ IcmpPacketType(icmp6header->icmp6_type));
+ }
+ preply.from.FreeAddrInfo(from);
+ return;
+@@ -331,7 +340,7 @@
+
+ Log(preply.from,
+ icmp6header->icmp6_type,
+- ( icmp6header->icmp6_type&0x80 ? icmp6HighPktStr[(int)(icmp6header->icmp6_type&0x7f)] : icmp6LowPktStr[(int)(icmp6header->icmp6_type&0x7f)] ),
++ IcmpPacketType(icmp6header->icmp6_type),
+ preply.rtt,
+ preply.hops);
+
+
diff --git a/net-proxy/squid/files/squid-13173_13171.patch b/net-proxy/squid/files/squid-13173_13171.patch
new file mode 100644
index 000000000000..da79daca674c
--- /dev/null
+++ b/net-proxy/squid/files/squid-13173_13171.patch
@@ -0,0 +1,274 @@
+=== modified file 'src/snmp_core.cc'
+--- src/snmp_core.cc 2014-02-18 08:46:49 +0000
++++ src/snmp_core.cc 2014-09-15 04:58:34 +0000
+@@ -362,7 +362,7 @@
+ void
+ snmpHandleUdp(int sock, void *not_used)
+ {
+- LOCAL_ARRAY(char, buf, SNMP_REQUEST_SIZE);
++ static char buf[SNMP_REQUEST_SIZE];
+ Ip::Address from;
+ SnmpRequest *snmp_rq;
+ int len;
+@@ -371,16 +371,11 @@
+
+ Comm::SetSelect(sock, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
+
+- memset(buf, '\0', SNMP_REQUEST_SIZE);
++ memset(buf, '\0', sizeof(buf));
+
+- len = comm_udp_recvfrom(sock,
+- buf,
+- SNMP_REQUEST_SIZE,
+- 0,
+- from);
++ len = comm_udp_recvfrom(sock, buf, sizeof(buf)-1, 0, from);
+
+ if (len > 0) {
+- buf[len] = '\0';
+ debugs(49, 3, "snmpHandleUdp: FD " << sock << ": received " << len << " bytes from " << from << ".");
+
+ snmp_rq = (SnmpRequest *)xcalloc(1, sizeof(SnmpRequest));
+
+=== modified file 'src/icmp/Icmp4.cc'
+--- src/icmp/Icmp4.cc 2013-06-03 14:05:16 +0000
++++ src/icmp/Icmp4.cc 2014-09-15 05:06:14 +0000
+@@ -41,26 +41,38 @@
+ #include "IcmpPinger.h"
+ #include "Debug.h"
+
+-const char *icmpPktStr[] = {
+- "Echo Reply",
+- "ICMP 1",
+- "ICMP 2",
+- "Destination Unreachable",
+- "Source Quench",
+- "Redirect",
+- "ICMP 6",
+- "ICMP 7",
+- "Echo",
+- "ICMP 9",
+- "ICMP 10",
+- "Time Exceeded",
+- "Parameter Problem",
+- "Timestamp",
+- "Timestamp Reply",
+- "Info Request",
+- "Info Reply",
+- "Out of Range Type"
+-};
++static const char *
++IcmpPacketType(uint8_t v)
++{
++ static const char *icmpPktStr[] = {
++ "Echo Reply",
++ "ICMP 1",
++ "ICMP 2",
++ "Destination Unreachable",
++ "Source Quench",
++ "Redirect",
++ "ICMP 6",
++ "ICMP 7",
++ "Echo",
++ "ICMP 9",
++ "ICMP 10",
++ "Time Exceeded",
++ "Parameter Problem",
++ "Timestamp",
++ "Timestamp Reply",
++ "Info Request",
++ "Info Reply",
++ "Out of Range Type"
++ };
++
++ if (v > 17) {
++ static char buf[50];
++ snprintf(buf, sizeof(buf), "ICMP %u (invalid)", v);
++ return buf;
++ }
++
++ return icmpPktStr[v];
++}
+
+ Icmp4::Icmp4() : Icmp()
+ {
+@@ -187,6 +199,12 @@
+ from->ai_addr,
+ &from->ai_addrlen);
+
++ if (n <= 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Error when calling recvfrom() on ICMP socket.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ preply.from = *from;
+
+ #if GETTIMEOFDAY_NO_TZP
+@@ -243,9 +261,15 @@
+
+ preply.psize = n - iphdrlen - (sizeof(icmpEchoData) - MAX_PKT4_SZ);
+
++ if (preply.psize < 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Malformed ICMP packet.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ control.SendResult(preply, (sizeof(pingerReplyData) - MAX_PKT4_SZ + preply.psize) );
+
+- Log(preply.from, icmp->icmp_type, icmpPktStr[icmp->icmp_type], preply.rtt, preply.hops);
++ Log(preply.from, icmp->icmp_type, IcmpPacketType(icmp->icmp_type), preply.rtt, preply.hops);
+ Ip::Address::FreeAddrInfo(from);
+ }
+
+
+=== modified file 'src/icmp/Icmp6.cc'
+--- src/icmp/Icmp6.cc 2013-06-03 14:05:16 +0000
++++ src/icmp/Icmp6.cc 2014-09-15 05:06:14 +0000
+@@ -50,57 +50,61 @@
+
+ // Icmp6 OP-Codes
+ // see http://www.iana.org/assignments/icmpv6-parameters
+-// NP: LowPktStr is for codes 0-127
+-static const char *icmp6LowPktStr[] = {
+- "ICMP 0", // 0
+- "Destination Unreachable", // 1 - RFC2463
+- "Packet Too Big", // 2 - RFC2463
+- "Time Exceeded", // 3 - RFC2463
+- "Parameter Problem", // 4 - RFC2463
+- "ICMP 5", // 5
+- "ICMP 6", // 6
+- "ICMP 7", // 7
+- "ICMP 8", // 8
+- "ICMP 9", // 9
+- "ICMP 10" // 10
+-};
+-
+-// NP: HighPktStr is for codes 128-255
+-static const char *icmp6HighPktStr[] = {
+- "Echo Request", // 128 - RFC2463
+- "Echo Reply", // 129 - RFC2463
+- "Multicast Listener Query", // 130 - RFC2710
+- "Multicast Listener Report", // 131 - RFC2710
+- "Multicast Listener Done", // 132 - RFC2710
+- "Router Solicitation", // 133 - RFC4861
+- "Router Advertisement", // 134 - RFC4861
+- "Neighbor Solicitation", // 135 - RFC4861
+- "Neighbor Advertisement", // 136 - RFC4861
+- "Redirect Message", // 137 - RFC4861
+- "Router Renumbering", // 138 - Crawford
+- "ICMP Node Information Query", // 139 - RFC4620
+- "ICMP Node Information Response", // 140 - RFC4620
+- "Inverse Neighbor Discovery Solicitation", // 141 - RFC3122
+- "Inverse Neighbor Discovery Advertisement", // 142 - RFC3122
+- "Version 2 Multicast Listener Report", // 143 - RFC3810
+- "Home Agent Address Discovery Request", // 144 - RFC3775
+- "Home Agent Address Discovery Reply", // 145 - RFC3775
+- "Mobile Prefix Solicitation", // 146 - RFC3775
+- "Mobile Prefix Advertisement", // 147 - RFC3775
+- "Certification Path Solicitation", // 148 - RFC3971
+- "Certification Path Advertisement", // 149 - RFC3971
+- "ICMP Experimental (150)", // 150 - RFC4065
+- "Multicast Router Advertisement", // 151 - RFC4286
+- "Multicast Router Solicitation", // 152 - RFC4286
+- "Multicast Router Termination", // 153 - [RFC4286]
+- "ICMP 154",
+- "ICMP 155",
+- "ICMP 156",
+- "ICMP 157",
+- "ICMP 158",
+- "ICMP 159",
+- "ICMP 160"
+-};
++static const char *
++IcmpPacketType(uint8_t v)
++{
++ // NP: LowPktStr is for codes 0-127
++ static const char *icmp6LowPktStr[] = {
++ "ICMPv6 0", // 0
++ "Destination Unreachable", // 1 - RFC2463
++ "Packet Too Big", // 2 - RFC2463
++ "Time Exceeded", // 3 - RFC2463
++ "Parameter Problem", // 4 - RFC2463
++ };
++
++ // low codes 1-4 registered
++ if (0 < v && v < 5)
++ return icmp6LowPktStr[(int)(v&0x7f)];
++
++ // NP: HighPktStr is for codes 128-255
++ static const char *icmp6HighPktStr[] = {
++ "Echo Request", // 128 - RFC2463
++ "Echo Reply", // 129 - RFC2463
++ "Multicast Listener Query", // 130 - RFC2710
++ "Multicast Listener Report", // 131 - RFC2710
++ "Multicast Listener Done", // 132 - RFC2710
++ "Router Solicitation", // 133 - RFC4861
++ "Router Advertisement", // 134 - RFC4861
++ "Neighbor Solicitation", // 135 - RFC4861
++ "Neighbor Advertisement", // 136 - RFC4861
++ "Redirect Message", // 137 - RFC4861
++ "Router Renumbering", // 138 - Crawford
++ "ICMP Node Information Query", // 139 - RFC4620
++ "ICMP Node Information Response", // 140 - RFC4620
++ "Inverse Neighbor Discovery Solicitation", // 141 - RFC3122
++ "Inverse Neighbor Discovery Advertisement", // 142 - RFC3122
++ "Version 2 Multicast Listener Report", // 143 - RFC3810
++ "Home Agent Address Discovery Request", // 144 - RFC3775
++ "Home Agent Address Discovery Reply", // 145 - RFC3775
++ "Mobile Prefix Solicitation", // 146 - RFC3775
++ "Mobile Prefix Advertisement", // 147 - RFC3775
++ "Certification Path Solicitation", // 148 - RFC3971
++ "Certification Path Advertisement", // 149 - RFC3971
++ "ICMP Experimental (150)", // 150 - RFC4065
++ "Multicast Router Advertisement", // 151 - RFC4286
++ "Multicast Router Solicitation", // 152 - RFC4286
++ "Multicast Router Termination", // 153 - [RFC4286]
++ };
++
++ // high codes 127-153 registered
++ if (127 < v && v < 154)
++ return icmp6HighPktStr[(int)(v&0x7f)];
++
++ // give all others a generic display
++ static char buf[50];
++ snprintf(buf, sizeof(buf), "ICMPv6 %u", v);
++ return buf;
++}
+
+ Icmp6::Icmp6() : Icmp()
+ {
+@@ -236,6 +240,12 @@
+ from->ai_addr,
+ &from->ai_addrlen);
+
++ if (n <= 0) {
++ debugs(42, DBG_CRITICAL, HERE << "Error when calling recvfrom() on ICMPv6 socket.");
++ Ip::Address::FreeAddrInfo(from);
++ return;
++ }
++
+ preply.from = *from;
+
+ #if GETTIMEOFDAY_NO_TZP
+@@ -291,8 +301,7 @@
+
+ default:
+ debugs(42, 8, HERE << preply.from << " said: " << icmp6header->icmp6_type << "/" << (int)icmp6header->icmp6_code << " " <<
+- ( icmp6header->icmp6_type&0x80 ? icmp6HighPktStr[(int)(icmp6header->icmp6_type&0x7f)] : icmp6LowPktStr[(int)(icmp6header->icmp6_type&0x7f)] )
+- );
++ IcmpPacketType(icmp6header->icmp6_type));
+ }
+ Ip::Address::FreeAddrInfo(from);
+ return;
+@@ -331,7 +340,7 @@
+
+ Log(preply.from,
+ icmp6header->icmp6_type,
+- ( icmp6header->icmp6_type&0x80 ? icmp6HighPktStr[(int)(icmp6header->icmp6_type&0x7f)] : icmp6LowPktStr[(int)(icmp6header->icmp6_type&0x7f)] ),
++ IcmpPacketType(icmp6header->icmp6_type),
+ preply.rtt,
+ preply.hops);
+
+
diff --git a/net-proxy/squid/squid-3.3.13-r1.ebuild b/net-proxy/squid/squid-3.3.13-r1.ebuild
new file mode 100644
index 000000000000..b924553329d5
--- /dev/null
+++ b/net-proxy/squid/squid-3.3.13-r1.ebuild
@@ -0,0 +1,250 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-proxy/squid/squid-3.3.13-r1.ebuild,v 1.1 2014/09/29 14:11:12 eras Exp $
+
+EAPI=5
+inherit autotools eutils linux-info pam toolchain-funcs user versionator
+
+DESCRIPTION="A full-featured web proxy cache"
+HOMEPAGE="http://www.squid-cache.org/"
+SRC_URI="ftp://ftp.squid-cache.org/pub/archive/3.3/${P}.tar.xz"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sparc ~x86 ~x86-fbsd"
+IUSE="caps ipv6 pam ldap samba sasl kerberos nis radius ssl snmp selinux logrotate test \
+ ecap icap-client ssl-crtd \
+ mysql postgres sqlite \
+ qos tproxy \
+ pf-transparent ipf-transparent kqueue \
+ elibc_uclibc kernel_linux"
+
+COMMON_DEPEND="caps? ( >=sys-libs/libcap-2.16 )
+ pam? ( virtual/pam )
+ ldap? ( net-nds/openldap )
+ kerberos? ( virtual/krb5 )
+ qos? ( net-libs/libnetfilter_conntrack )
+ ssl? ( dev-libs/openssl )
+ sasl? ( dev-libs/cyrus-sasl )
+ ecap? ( net-libs/libecap:0.2 )
+ selinux? ( sec-policy/selinux-squid )
+ !x86-fbsd? ( logrotate? ( app-admin/logrotate ) )
+ >=sys-libs/db-4
+ sys-devel/libtool
+ dev-lang/perl
+ sys-devel/libtool"
+DEPEND="${COMMON_DEPEND}
+ sys-apps/ed
+ test? ( dev-util/cppunit )"
+RDEPEND="${COMMON_DEPEND}
+ samba? ( net-fs/samba )
+ mysql? ( dev-perl/DBD-mysql )
+ postgres? ( dev-perl/DBD-Pg )
+ sqlite? ( dev-perl/DBD-SQLite )
+ !<=sci-biology/meme-4.8.1-r1"
+
+REQUIRED_USE="tproxy? ( caps )
+ qos? ( caps )"
+
+pkg_pretend() {
+ if use tproxy; then
+ local CONFIG_CHECK="~NF_CONNTRACK ~NETFILTER_TPROXY ~NETFILTER_XT_MATCH_SOCKET ~NETFILTER_XT_TARGET_TPROXY"
+ linux-info_pkg_setup
+ fi
+}
+
+pkg_setup() {
+ enewgroup squid 31
+ enewuser squid 31 -1 /var/cache/squid squid
+}
+
+src_prepare() {
+ epatch "${FILESDIR}/${PN}-3.3.4-gentoo.patch"
+ epatch "${FILESDIR}/${PN}-12683_12681.patch"
+ sed -i -e 's:AM_CONFIG_HEADER:AC_CONFIG_HEADERS:' \
+ lib/libTrie/configure.ac || die
+ sed -i -e 's:/usr/local/squid/etc:/etc/squid:' \
+ INSTALL QUICKSTART \
+ helpers/basic_auth/MSNT/README.html \
+ helpers/basic_auth/MSNT/confload.cc \
+ helpers/basic_auth/MSNT/msntauth.conf.default \
+ scripts/fileno-to-pathname.pl \
+ scripts/check_cache.pl \
+ tools/cachemgr.cgi.8 \
+ tools/purge/conffile.hh \
+ tools/purge/README || die
+ sed -i -e 's:/usr/local/squid/sbin:/usr/sbin:' \
+ INSTALL QUICKSTART || die
+ sed -i -e 's:/usr/local/squid/var/cache:/var/cache/squid:' \
+ QUICKSTART || die
+ sed -i -e 's:/usr/local/squid/var/logs:/var/log/squid:' \
+ QUICKSTART \
+ src/log/access_log.cc || die
+ sed -i -e 's:/usr/local/squid/logs:/var/log/squid:' \
+ src/log/access_log.cc || die
+ sed -i -e 's:/usr/local/squid/bin:/usr/bin:' \
+ helpers/basic_auth/MSNT/README.html || die
+ sed -i -e 's:/usr/local/squid/libexec:/usr/libexec/squid:' \
+ helpers/external_acl/unix_group/ext_unix_group_acl.8 \
+ helpers/external_acl/session/ext_session_acl.8 \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/usr/local/squid/cache:/var/cache/squid:' \
+ scripts/check_cache.pl || die
+ sed -i -e 's:/usr/local/squid/ssl_cert:/etc/ssl/squid:' \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/usr/local/squid/var/lib/ssl_db:/var/lib/squid/ssl_db:' \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/var/lib/ssl_db:/var/lib/squid/ssl_db:' \
+ src/ssl/ssl_crtd.8 || die
+ # /var/run/squid to /run/squid
+ sed -i -e 's:$(localstatedir)::' \
+ src/ipc/Makefile.am
+
+ epatch_user
+
+ # Bug #419685 - eautoreconf in src_prepare() fails in libltdl/
+ # aclocal-1.11: `configure.ac' or `configure.in' is required
+ MAKEOPTS="${MAKEOPTS} -j1" eautoreconf
+}
+
+src_configure() {
+ local basic_modules="MSNT,MSNT-multi-domain,NCSA,POP3,getpwnam"
+ use samba && basic_modules+=",SMB"
+ use ldap && basic_modules+=",LDAP"
+ use pam && basic_modules+=",PAM"
+ use sasl && basic_modules+=",SASL"
+ use nis && ! use elibc_uclibc && basic_modules+=",NIS"
+ use radius && basic_modules+=",RADIUS"
+ if use mysql || use postgres || use sqlite ; then
+ basic_modules+=",DB"
+ fi
+
+ local digest_modules="file"
+ use ldap && digest_modules+=",LDAP,eDirectory"
+
+ local negotiate_modules myconf
+ if use kerberos ; then
+ negotiate_modules="kerberos,wrapper"
+ myconf="--with-krb5-config=yes"
+ else
+ negotiate_modules="none"
+ myconf="--with-krb5-config=no"
+ fi
+
+ local ntlm_modules="none"
+ use samba && ntlm_modules="smb_lm"
+
+ local ext_helpers="file_userip,session,unix_group"
+ use samba && ext_helpers+=",wbinfo_group"
+ use ldap && ext_helpers+=",LDAP_group,eDirectory_userip"
+ use ldap && use kerberos && ext_helpers+=",kerberos_ldap_group"
+
+ # uclibc does not have aio support - needed for coss (#61175)
+ local storeio_modules="aufs,diskd,rock,ufs"
+
+ local transparent
+ if use kernel_linux ; then
+ transparent+=" --enable-linux-netfilter"
+ use qos && transparent+=" --enable-zph-qos --with-netfilter-conntrack"
+ fi
+
+ if use kernel_FreeBSD || use kernel_OpenBSD || use kernel_NetBSD ; then
+ transparent+=" $(use_enable kqueue)"
+ if use pf-transparent; then
+ transparent+=" --enable-pf-transparent"
+ elif use ipf-transparent; then
+ transparent+=" --enable-ipf-transparent"
+ fi
+ fi
+
+ tc-export CC AR
+
+ econf \
+ --sysconfdir=/etc/squid \
+ --libexecdir=/usr/libexec/squid \
+ --localstatedir=/var \
+ --with-pidfile=/run/squid.pid \
+ --datadir=/usr/share/squid \
+ --with-logdir=/var/log/squid \
+ --with-default-user=squid \
+ --enable-removal-policies="lru,heap" \
+ --enable-storeio="${storeio_modules}" \
+ --enable-disk-io \
+ --enable-auth \
+ --enable-auth-basic="${basic_modules}" \
+ --enable-auth-digest="${digest_modules}" \
+ --enable-auth-ntlm="${ntlm_modules}" \
+ --enable-auth-negotiate="${negotiate_modules}" \
+ --enable-external-acl-helpers="${ext_helpers}" \
+ --enable-log-daemon-helpers \
+ --enable-url-rewrite-helpers \
+ --enable-cache-digests \
+ --enable-delay-pools \
+ --enable-eui \
+ --enable-icmp \
+ --enable-follow-x-forwarded-for \
+ --enable-esi \
+ --with-large-files \
+ --disable-strict-error-checking \
+ $(use_with caps libcap) \
+ $(use_enable ipv6) \
+ $(use_enable snmp) \
+ $(use_enable ssl) \
+ $(use_enable ssl-crtd) \
+ $(use_enable icap-client) \
+ $(use_enable ecap) \
+ ${transparent} \
+ ${myconf}
+}
+
+src_install() {
+ emake DESTDIR="${D}" install
+
+ # need suid root for looking into /etc/shadow
+ fowners root:squid /usr/libexec/squid/basic_ncsa_auth
+ fperms 4750 /usr/libexec/squid/basic_ncsa_auth
+ if use pam; then
+ fowners root:squid /usr/libexec/squid/basic_pam_auth
+ fperms 4750 /usr/libexec/squid/basic_pam_auth
+ fi
+ # pinger needs suid as well
+ fowners root:squid /usr/libexec/squid/pinger
+ fperms 4750 /usr/libexec/squid/pinger
+
+ # some cleanups
+ rm -f "${D}"/usr/bin/Run*
+ rm -rf "${D}"/run/squid "${D}"/var/cache/squid
+
+ dodoc CONTRIBUTORS CREDITS ChangeLog INSTALL QUICKSTART README SPONSORS doc/*.txt
+ newdoc helpers/negotiate_auth/kerberos/README README.kerberos
+ newdoc helpers/basic_auth/MSNT-multi-domain/README.txt README.MSNT-multi-domain
+ newdoc helpers/basic_auth/LDAP/README README.LDAP
+ newdoc helpers/basic_auth/RADIUS/README README.RADIUS
+ newdoc helpers/external_acl/kerberos_ldap_group/README README.kerberos_ldap_group
+ newdoc tools/purge/README README.purge
+ newdoc tools/helper-mux.README README.helper-mux
+ dohtml RELEASENOTES.html
+
+ newpamd "${FILESDIR}/squid.pam" squid
+ newconfd "${FILESDIR}/squid.confd-r1" squid
+ newinitd "${FILESDIR}/squid.initd-r4" squid
+ if use logrotate; then
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}/squid.logrotate" squid
+ else
+ exeinto /etc/cron.weekly
+ newexe "${FILESDIR}/squid.cron" squid.cron
+ fi
+
+ diropts -m0750 -o squid -g squid
+ keepdir /var/log/squid /etc/ssl/squid /var/lib/squid
+}
+
+pkg_postinst() {
+ if [[ $(get_version_component_range 1 ${REPLACING_VERSIONS}) -lt 3 ]] || \
+ [[ $(get_version_component_range 2 ${REPLACING_VERSIONS}) -lt 3 ]]; then
+ elog "Please read the release notes at:"
+ elog " http://www.squid-cache.org/Versions/v3/3.3/RELEASENOTES.html"
+ echo
+ fi
+}
diff --git a/net-proxy/squid/squid-3.4.7-r1.ebuild b/net-proxy/squid/squid-3.4.7-r1.ebuild
new file mode 100644
index 000000000000..d4c3de65269a
--- /dev/null
+++ b/net-proxy/squid/squid-3.4.7-r1.ebuild
@@ -0,0 +1,256 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-proxy/squid/squid-3.4.7-r1.ebuild,v 1.1 2014/09/29 14:11:12 eras Exp $
+
+EAPI=5
+inherit autotools eutils linux-info pam toolchain-funcs user versionator
+
+DESCRIPTION="A full-featured web proxy cache"
+HOMEPAGE="http://www.squid-cache.org/"
+SRC_URI="ftp://ftp.squid-cache.org/pub/archive/3.4/${P}.tar.xz"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sparc ~x86 ~x86-fbsd"
+IUSE="caps ipv6 pam ldap samba sasl kerberos nis radius ssl snmp selinux logrotate test \
+ ecap esi icap-client ssl-crtd \
+ mysql postgres sqlite \
+ qos tproxy \
+ +htcp +wccp +wccpv2 \
+ pf-transparent ipf-transparent kqueue \
+ elibc_uclibc kernel_linux"
+
+COMMON_DEPEND="caps? ( >=sys-libs/libcap-2.16 )
+ pam? ( virtual/pam )
+ ldap? ( net-nds/openldap )
+ kerberos? ( virtual/krb5 )
+ qos? ( net-libs/libnetfilter_conntrack )
+ ssl? ( dev-libs/openssl dev-libs/nettle )
+ sasl? ( dev-libs/cyrus-sasl )
+ ecap? ( net-libs/libecap:0.2 )
+ esi? ( dev-libs/expat dev-libs/libxml2 )
+ selinux? ( sec-policy/selinux-squid )
+ !x86-fbsd? ( logrotate? ( app-admin/logrotate ) )
+ >=sys-libs/db-4
+ sys-devel/libtool
+ dev-lang/perl
+ sys-devel/libtool"
+DEPEND="${COMMON_DEPEND}
+ ecap? ( virtual/pkgconfig )
+ sys-apps/ed
+ test? ( dev-util/cppunit )"
+RDEPEND="${COMMON_DEPEND}
+ samba? ( net-fs/samba )
+ mysql? ( dev-perl/DBD-mysql )
+ postgres? ( dev-perl/DBD-Pg )
+ sqlite? ( dev-perl/DBD-SQLite )
+ !<=sci-biology/meme-4.8.1-r1"
+
+REQUIRED_USE="tproxy? ( caps )
+ qos? ( caps )"
+
+pkg_pretend() {
+ if use tproxy; then
+ local CONFIG_CHECK="~NF_CONNTRACK ~NETFILTER_TPROXY ~NETFILTER_XT_MATCH_SOCKET ~NETFILTER_XT_TARGET_TPROXY"
+ linux-info_pkg_setup
+ fi
+}
+
+pkg_setup() {
+ enewgroup squid 31
+ enewuser squid 31 -1 /var/cache/squid squid
+}
+
+src_prepare() {
+ epatch "${FILESDIR}/${PN}-3.3.4-gentoo.patch"
+ epatch "${FILESDIR}/${PN}-13173_13171.patch"
+ sed -i -e 's:/usr/local/squid/etc:/etc/squid:' \
+ INSTALL QUICKSTART \
+ helpers/basic_auth/MSNT/README.html \
+ helpers/basic_auth/MSNT/confload.cc \
+ helpers/basic_auth/MSNT/msntauth.conf.default \
+ scripts/fileno-to-pathname.pl \
+ scripts/check_cache.pl \
+ tools/cachemgr.cgi.8 \
+ tools/purge/conffile.hh \
+ tools/purge/README || die
+ sed -i -e 's:/usr/local/squid/sbin:/usr/sbin:' \
+ INSTALL QUICKSTART || die
+ sed -i -e 's:/usr/local/squid/var/cache:/var/cache/squid:' \
+ QUICKSTART || die
+ sed -i -e 's:/usr/local/squid/var/logs:/var/log/squid:' \
+ QUICKSTART \
+ src/log/access_log.cc || die
+ sed -i -e 's:/usr/local/squid/logs:/var/log/squid:' \
+ src/log/access_log.cc || die
+ sed -i -e 's:/usr/local/squid/bin:/usr/bin:' \
+ helpers/basic_auth/MSNT/README.html || die
+ sed -i -e 's:/usr/local/squid/libexec:/usr/libexec/squid:' \
+ helpers/external_acl/unix_group/ext_unix_group_acl.8 \
+ helpers/external_acl/session/ext_session_acl.8 \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/usr/local/squid/cache:/var/cache/squid:' \
+ scripts/check_cache.pl || die
+ sed -i -e 's:/usr/local/squid/ssl_cert:/etc/ssl/squid:' \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/usr/local/squid/var/lib/ssl_db:/var/lib/squid/ssl_db:' \
+ src/ssl/ssl_crtd.8 || die
+ sed -i -e 's:/var/lib/ssl_db:/var/lib/squid/ssl_db:' \
+ src/ssl/ssl_crtd.8 || die
+ # /var/run/squid to /run/squid
+ sed -i -e 's:$(localstatedir)::' \
+ src/ipc/Makefile.am
+
+ epatch_user
+
+ # Bug #419685 - eautoreconf in src_prepare() fails in libltdl/
+ # aclocal-1.11: `configure.ac' or `configure.in' is required
+ MAKEOPTS="${MAKEOPTS} -j1" eautoreconf
+}
+
+src_configure() {
+ local basic_modules="MSNT,MSNT-multi-domain,NCSA,POP3,getpwnam"
+ use samba && basic_modules+=",SMB"
+ use ldap && basic_modules+=",LDAP"
+ use pam && basic_modules+=",PAM"
+ use sasl && basic_modules+=",SASL"
+ use nis && ! use elibc_uclibc && basic_modules+=",NIS"
+ use radius && basic_modules+=",RADIUS"
+ if use mysql || use postgres || use sqlite ; then
+ basic_modules+=",DB"
+ fi
+
+ local digest_modules="file"
+ use ldap && digest_modules+=",LDAP,eDirectory"
+
+ local negotiate_modules myconf
+ if use kerberos ; then
+ negotiate_modules="kerberos,wrapper"
+ myconf="--with-krb5-config=yes"
+ else
+ negotiate_modules="none"
+ myconf="--with-krb5-config=no"
+ fi
+
+ local ntlm_modules="none"
+ use samba && ntlm_modules="smb_lm"
+
+ local ext_helpers="file_userip,session,unix_group"
+ use samba && ext_helpers+=",wbinfo_group"
+ use ldap && ext_helpers+=",LDAP_group,eDirectory_userip"
+ use ldap && use kerberos && ext_helpers+=",kerberos_ldap_group"
+
+ # uclibc does not have aio support - needed for coss (#61175)
+ local storeio_modules="aufs,diskd,rock,ufs"
+
+ local transparent
+ if use kernel_linux ; then
+ transparent+=" --enable-linux-netfilter"
+ use qos && transparent+=" --enable-zph-qos --with-netfilter-conntrack"
+ fi
+
+ if use kernel_FreeBSD || use kernel_OpenBSD || use kernel_NetBSD ; then
+ transparent+=" $(use_enable kqueue)"
+ if use pf-transparent; then
+ transparent+=" --enable-pf-transparent"
+ elif use ipf-transparent; then
+ transparent+=" --enable-ipf-transparent"
+ fi
+ fi
+
+ tc-export CC AR
+
+ econf \
+ --sysconfdir=/etc/squid \
+ --libexecdir=/usr/libexec/squid \
+ --localstatedir=/var \
+ --with-pidfile=/run/squid.pid \
+ --datadir=/usr/share/squid \
+ --with-logdir=/var/log/squid \
+ --with-default-user=squid \
+ --enable-removal-policies="lru,heap" \
+ --enable-storeio="${storeio_modules}" \
+ --enable-disk-io \
+ --enable-auth \
+ --enable-auth-basic="${basic_modules}" \
+ --enable-auth-digest="${digest_modules}" \
+ --enable-auth-ntlm="${ntlm_modules}" \
+ --enable-auth-negotiate="${negotiate_modules}" \
+ --enable-external-acl-helpers="${ext_helpers}" \
+ --enable-log-daemon-helpers \
+ --enable-url-rewrite-helpers \
+ --enable-cache-digests \
+ --enable-delay-pools \
+ --enable-eui \
+ --enable-icmp \
+ --enable-follow-x-forwarded-for \
+ --with-large-files \
+ --disable-strict-error-checking \
+ --disable-arch-native \
+ $(use_with caps libcap) \
+ $(use_enable ipv6) \
+ $(use_enable snmp) \
+ $(use_enable ssl) \
+ $(use_with ssl nettle) \
+ $(use_enable ssl-crtd) \
+ $(use_enable icap-client) \
+ $(use_enable ecap) \
+ $(use_enable esi) \
+ $(use_enable htcp) \
+ $(use_enable wccp) \
+ $(use_enable wccpv2) \
+ ${transparent} \
+ ${myconf}
+}
+
+src_install() {
+ emake DESTDIR="${D}" install
+
+ # need suid root for looking into /etc/shadow
+ fowners root:squid /usr/libexec/squid/basic_ncsa_auth
+ fperms 4750 /usr/libexec/squid/basic_ncsa_auth
+ if use pam; then
+ fowners root:squid /usr/libexec/squid/basic_pam_auth
+ fperms 4750 /usr/libexec/squid/basic_pam_auth
+ fi
+ # pinger needs suid as well
+ fowners root:squid /usr/libexec/squid/pinger
+ fperms 4750 /usr/libexec/squid/pinger
+
+ # cleanup
+ rm -f "${D}"/usr/bin/Run*
+ rm -rf "${D}"/run/squid "${D}"/var/cache/squid
+
+ dodoc CONTRIBUTORS CREDITS ChangeLog INSTALL QUICKSTART README SPONSORS doc/*.txt
+ newdoc helpers/negotiate_auth/kerberos/README README.kerberos
+ newdoc helpers/basic_auth/MSNT-multi-domain/README.txt README.MSNT-multi-domain
+ newdoc helpers/basic_auth/LDAP/README README.LDAP
+ newdoc helpers/basic_auth/RADIUS/README README.RADIUS
+ newdoc helpers/external_acl/kerberos_ldap_group/README README.kerberos_ldap_group
+ newdoc tools/purge/README README.purge
+ newdoc tools/helper-mux.README README.helper-mux
+ dohtml RELEASENOTES.html
+
+ newpamd "${FILESDIR}/squid.pam" squid
+ newconfd "${FILESDIR}/squid.confd-r1" squid
+ newinitd "${FILESDIR}/squid.initd-r4" squid
+ if use logrotate; then
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}/squid.logrotate" squid
+ else
+ exeinto /etc/cron.weekly
+ newexe "${FILESDIR}/squid.cron" squid.cron
+ fi
+
+ diropts -m0750 -o squid -g squid
+ keepdir /var/log/squid /etc/ssl/squid /var/lib/squid
+}
+
+pkg_postinst() {
+ if [[ $(get_version_component_range 1 ${REPLACING_VERSIONS}) -lt 3 ]] || \
+ [[ $(get_version_component_range 2 ${REPLACING_VERSIONS}) -lt 4 ]]; then
+ elog "Please read the release notes at:"
+ elog " http://www.squid-cache.org/Versions/v3/3.4/RELEASENOTES.html"
+ echo
+ fi
+}